using System;
using System.Diagnostics;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace SafeReadyCheck
{
	public class SafeReadyCheck : HBPlugin
	{
		public override string Name { get { return "SafeReadyCheck"; } }
		public override string Author { get { return "namednoob"; } }
		public override Version Version { get { return new Version(0, 0, 0, 1); } }
		public override bool WantButton { get { return false; } }
		public override string ButtonText { get { return "SafeReadyCheck"; } }

		private static readonly Stopwatch MyTimer = new Stopwatch();
		private static Random _random = new Random();
		private static LocalPlayer Me { get { return StyxWoW.Me; } }
		private bool _accept = false;
		private int _acceptWhen = 0;

		public SafeReadyCheck()
		{
		}

		public override void OnEnable()
		{
			base.OnEnable();
			Logging.Write(Colors.Orange, Name + " - Enabled v" + Version);
			Lua.Events.AttachEvent("READY_CHECK", ReadyCheckEvent);
		}

		public override void OnDisable()
		{
			Lua.Events.DetachEvent("READY_CHECK", ReadyCheckEvent);
			Logging.Write(Colors.Orange, Name + " - Disabled");
			MyTimer.Stop();
			MyTimer.Reset();
			base.OnDisable();
		}

		public override void Pulse()
		{
			// Do not run the macro if we are not in game, 
			// or have received an accept request
			// or if we are dead
			if (!StyxWoW.IsInGame)
			{
				_accept = false;
				_acceptWhen = 0;
				return;
			}

			// We don't want to run any code if the event did not trigger
			if (!_accept)
			{
				return;
			}

			// If we got a request then timer must be running
			if (!MyTimer.IsRunning)
			{
				MyTimer.Start();
			}

			// Thread.Sleep is evil, we go this route!!
			if (MyTimer.ElapsedMilliseconds < _acceptWhen)
			{
				int result = TimeSpan.FromMilliseconds(_acceptWhen - MyTimer.ElapsedMilliseconds).Seconds;
				if (result <= 5)
				{
					Logging.Write(Colors.White, string.Format("[{0}] {1}", Name, result));
				}
				return;
			}

			// We are dead and as such not ready
			if (Me.IsDead || Me.IsGhost)
			{
				Logging.Write(Colors.OrangeRed, string.Format("[{0}] Clicking the NO button, as we are dead and not ready!", Name));
				Lua.DoString("RunMacroText(\"/click ReadyCheckFrameNoButton\");");
			}
			// We are not dead hence we are ready
			else
			{
				Logging.Write(Colors.LimeGreen, string.Format("[{0}] Clicking the YES button now!", Name));
				Lua.DoString("RunMacroText(\"/click ReadyCheckFrameYesButton\");");
			}

			// reset settings for next event
			_accept = false;
			_acceptWhen = 0;
			MyTimer.Stop();
			MyTimer.Reset();
		}

		/// <summary>
		/// Initiate event
		/// </summary>
		public void ReadyCheckEvent(object sender, LuaEventArgs args)
		{
			_accept = true;
			_acceptWhen = _random.Next(1000, 7000);
			Logging.Write(Colors.Orange, string.Format("[{0}] Ready Check event trigged, accepting it in {1} second(s)...", Name, TimeSpan.FromMilliseconds((double)_acceptWhen).Seconds));
		}
	}
}